diff -uwrN sourceold/scripts/jmgUtility.cpp source/scripts/jmgUtility.cpp
--- sourceold/scripts/jmgUtility.cpp	2016-12-17 21:07:23.265015700 +1000
+++ source/scripts/jmgUtility.cpp	2017-01-22 19:51:59.210626000 +1000
@@ -7034,7 +7129,722 @@
 		Commands->Start_Timer(obj,this,0.1f,1);
 	}
 }
-
+void JMG_Utility_Send_Custom_When_No_More_Presets_Of_Type_Exist::Created(GameObject *obj)
+{
+	sprintf(presetName,"%s",Get_Parameter("PresetName"));
+	enableCustom = Get_Int_Parameter("EnableOrDisableCustom");
+	enabled = Get_Int_Parameter("StartsEnabled") ? true : false;
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Send_Custom_When_No_More_Presets_Of_Type_Exist::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == enableCustom)
+	{
+		enabled = param ? true : false;
+	}
+}
+void JMG_Utility_Send_Custom_When_No_More_Presets_Of_Type_Exist::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (enabled)
+		{
+			bool found = false;
+			for (SLNode<BaseGameObj> *current = GameObjManager::GameObjList.Head();current;current = current->Next())
+			{
+				GameObject* o = current->Data()->As_ScriptableGameObj();
+				if (!_stricmp(Commands->Get_Preset_Name(o),presetName))
+					found = true;
+			}
+			if (!found)
+			{
+				int id = Get_Int_Parameter("ID");
+				GameObject *object = id ? Commands->Find_Object(id) : obj;
+				if (object)
+					Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("Custom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+				this->Destroy_Script();
+				return;
+			}
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+void JMG_Utility_Send_Custom_When_Player_Outside_Of_Range::Created(GameObject *obj)
+{
+	sleeping = 0;
+	distance = Get_Float_Parameter("Distance");
+	id = Get_Int_Parameter("ID");
+	custom = Get_Int_Parameter("Custom");
+	param = Get_Int_Parameter("Param");
+	delay = Get_Float_Parameter("Delay");
+	distance *= distance;
+	triggerOnce = Get_Int_Parameter("TriggerOnce") ? true : false;
+	sleepTime = Get_Int_Parameter("SleepTime");
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Send_Custom_When_Player_Outside_Of_Range::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 1)
+	{
+		if (sleeping)
+			sleeping--;
+		else
+			for (int x = 1;x < 128;x++)
+			{
+				GameObject *player = Get_GameObj(x);
+				if (!player)
+					continue;
+				if (JmgUtility::SimpleDistance(Commands->Get_Position(player),Commands->Get_Position(obj)) > distance)
+				{
+					GameObject *object = id ? Commands->Find_Object(id) : obj;
+					if (object)
+						Commands->Send_Custom_Event(obj,object,custom,param,delay);
+					if (triggerOnce)
+					{
+						this->Destroy_Script();
+						return;
+					}
+				}
+			}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+void JMG_Utility_Set_Team_To_Neutral_When_No_Armor::Created(GameObject *obj)
+{
+	hurt = false;
+	originalPlayerType = Commands->Get_Player_Type(obj);
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Set_Team_To_Neutral_When_No_Armor::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (hurt && Commands->Get_Shield_Strength(obj) >= Commands->Get_Max_Shield_Strength(obj))
+		{
+			hurt = false;
+			Commands->Set_Player_Type(obj,originalPlayerType);
+		}
+		if (!hurt && !Commands->Get_Shield_Strength(obj))
+		{
+			hurt = true;
+			Commands->Set_Player_Type(obj,-2);
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+void JMG_Utility_Send_Custom_When_No_More_Units_On_Team_Exist::Created(GameObject *obj)
+{
+	team = Get_Int_Parameter("Team");
+	enableCustom = Get_Int_Parameter("EnableOrDisableCustom");
+	enabled = Get_Int_Parameter("StartsEnabled") ? true : false;
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Send_Custom_When_No_More_Units_On_Team_Exist::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == enableCustom)
+	{
+		enabled = param ? true : false;
+	}
+}
+void JMG_Utility_Send_Custom_When_No_More_Units_On_Team_Exist::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (enabled)
+		{
+			bool found = false;
+			for (SLNode<SmartGameObj> *current = GameObjManager::SmartGameObjList.Head();current;current = current->Next())
+			{
+				GameObject* o = current->Data()->As_ScriptableGameObj();
+				if (Commands->Get_Player_Type(o) == team && !Is_Script_Attached(o,"JMG_Utility_Send_Custom_When_No_More_Units_On_Team_Exist_Ignore"))
+					found = true;
+			}
+			if (!found)
+			{
+				int id = Get_Int_Parameter("ID");
+				GameObject *object = id ? Commands->Find_Object(id) : obj;
+				if (object)
+					Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("Custom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+				this->Destroy_Script();
+				return;
+			}
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+void JMG_Utility_Custom_Create_Sound_At_Object_Bone::Created(GameObject *obj)
+{
+	sprintf(sound,"%s",Get_Parameter("Sound"));
+	sprintf(bone,"%s",Get_Parameter("Bone"));
+	custom = Get_Int_Parameter("Custom");
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Custom_Create_Sound_At_Object_Bone::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == custom)
+	{
+		Commands->Create_3D_Sound_At_Bone(sound,obj,bone);
+	}
+}
+void JMG_Utility_Custom_Send_Custom_On_Player_Count::Created(GameObject *obj)
+{
+	runningCount = 0;
+	custom = Get_Int_Parameter("Custom");
+	resetCustom = Get_Int_Parameter("ResetCustom");
+	baseCount = Get_Int_Parameter("BaseCount");
+	playerCount = Get_Int_Parameter("PlayerCount");
+}
+void JMG_Utility_Custom_Send_Custom_On_Player_Count::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == resetCustom)
+	{
+		runningCount = 0;
+	}
+	if (message == custom)
+	{
+		runningCount++;
+		if (runningCount < baseCount+playerCount*Get_Player_Count())
+			return;
+		int id = Get_Int_Parameter("ID");
+		GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
+		if (object)
+			Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("SendCustom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+		this->Destroy_Script();
+	}
+}
+void JMG_Utility_Killed_By_Player_Send_Custom::Killed(GameObject *obj,GameObject *killer)
+{
+	if (!Commands->Is_A_Star(killer))
+		return;
+	int id = Get_Int_Parameter("ID");
+	GameObject *object = id ? (id == -1 ? killer : Commands->Find_Object(id)) : obj;
+	Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("Custom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+	Destroy_Script();
+}
+void JMG_Utility_AI_Guardian_Ignored::Created(GameObject *obj)
+{
+}
+void JMG_Utility_AI_Vehicle_Ignored::Created(GameObject *obj)
+{
+}
+void JMG_Utility_Killed_By_PresetID_Send_Custom::Killed(GameObject *obj,GameObject *killer)
+{
+	if (Commands->Get_Preset_ID(killer) != Get_Int_Parameter("PresetID"))
+		return;
+	int id = Get_Int_Parameter("ID");
+	GameObject *object = id ? (id == -1 ? killer : Commands->Find_Object(id)) : obj;
+	Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("Custom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+	Destroy_Script();
+}
+void JMG_Utility_Created_Override_AI_Soldier_Muzzle_Direction::Created(GameObject *obj)
+{
+	if (obj->As_SoldierGameObj())
+		obj->As_SoldierGameObj()->Set_Override_Muzzle_Direction(true);
+	this->Destroy_Script();
+}
+void JMG_Utility_Custom_Send_Custom_On_Player_Count_HUD::Created(GameObject *obj)
+{
+	hudStringId = Get_Int_Parameter("HudStringId");
+	sprintf(hudMessage,"%s",Get_Translated_String(hudStringId));
+	hudStringColor = Get_Vector3_Parameter("HudStringColor");
+	runningCount = 0;
+	custom = Get_Int_Parameter("Custom");
+	resetCustom = Get_Int_Parameter("ResetCustom");
+	baseCount = Get_Int_Parameter("BaseCount");
+	playerCount = Get_Int_Parameter("PlayerCount");
+}
+void JMG_Utility_Custom_Send_Custom_On_Player_Count_HUD::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == resetCustom)
+	{
+		runningCount = 0;
+	}
+	if (message == custom)
+	{
+		runningCount++;
+		int requiredCount = baseCount+playerCount*Get_Player_Count();
+		JmgUtility::SetHUDHelpText(hudStringId,formatHUDMessage(hudMessage,runningCount,requiredCount),hudStringColor);
+		if (runningCount < requiredCount)
+			return;
+		int id = Get_Int_Parameter("ID");
+		GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
+		if (object)
+			Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("SendCustom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+		this->Destroy_Script();
+	}
+}
+char *JMG_Utility_Custom_Send_Custom_On_Player_Count_HUD::formatHUDMessage(const char *format,...)
+{
+	static char displayMsg[256];
+	va_list args;
+	va_start(args,format);
+	vsprintf(displayMsg,format,args);
+	va_end(args);
+	return displayMsg;
+}
+void JMG_Utility_Zone_Send_Custom_If_Has_Weapon_Ammo::Entered(GameObject *obj,GameObject *enter)
+{
+	if (CheckPlayerType(enter,Get_Int_Parameter("PlayerType")) || Commands->Get_Player_Type(enter) == -4)
+		return;
+	char weaponName[256];
+	sprintf(weaponName,"%s",Get_Parameter("WeaponName"));
+	if (!Has_Weapon(enter,weaponName))
+		return;
+	int totalBullets = Get_Total_Bullets(enter,weaponName);
+	int id = Get_Int_Parameter("ID");
+	GameObject *object = id ? (id == -1 ? enter : Commands->Find_Object(id)) : obj;
+	if (object && totalBullets)
+		for (int x = 0;x < totalBullets;x++)
+			Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("Custom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+	if (Get_Int_Parameter("RemoveWeapon"))
+		Remove_Weapon(enter,weaponName);
+	if (Get_Int_Parameter("TriggerOnce"))
+		Destroy_Script();
+}
+void JMG_Utility_Custom_Remove_Weapon_From_All_Players::Created(GameObject *obj)
+{
+	custom = Get_Int_Parameter("Custom");
+	sprintf(weaponName,"%s",Get_Parameter("WeaponName"));
+}
+void JMG_Utility_Custom_Remove_Weapon_From_All_Players::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == custom)
+	{
+		for (int x = 1;x < 128;x++)
+		{
+			GameObject *player = Get_GameObj(x);
+			if (!player || !Has_Weapon(player,weaponName))
+				continue;
+			Remove_Weapon(player,weaponName);
+		}
+	}
+}
+void JMG_Utility_Custom_Destroy_All_Presets_By_Name::Created(GameObject *obj)
+{
+	sprintf(presetName,"%s",Get_Parameter("PresetName"));
+	custom = Get_Int_Parameter("Custom");
+}
+void JMG_Utility_Custom_Destroy_All_Presets_By_Name::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == custom)
+	{
+		for (SLNode<BaseGameObj> *current = GameObjManager::GameObjList.Head();current;current = current->Next())
+		{
+			GameObject* o = current->Data()->As_ScriptableGameObj();
+			if (!_stricmp(presetName,Commands->Get_Preset_Name(o)))
+				Commands->Destroy_Object(o);
+		}
+	}
+}
+void JMG_Utility_Send_Custom_When_Damage_Exceedes_Threshold::Created(GameObject *obj)
+{
+	id = Get_Int_Parameter("ID");
+	custom = Get_Int_Parameter("Custom");
+	param = Get_Int_Parameter("Param");
+	delay = Get_Float_Parameter("Delay");
+	damageThreshold = Get_Float_Parameter("DamageThreshold");
+	lockoutTime = Get_Float_Parameter("LockoutTime");
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Send_Custom_When_Damage_Exceedes_Threshold::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (timeRemaining)
+		{
+			timeRemaining -= 0.1f;
+			if (timeRemaining < 0)
+				timeRemaining = 0.0f;
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+void JMG_Utility_Send_Custom_When_Damage_Exceedes_Threshold::Damaged(GameObject *obj,GameObject *damager,float damage)
+{
+	if (damage < damageThreshold)
+		return;
+	if (timeRemaining)
+		return;
+	timeRemaining = lockoutTime;
+	GameObject *object = id ? (id == -1 ? damager : Commands->Find_Object(id)) : obj;
+	if (object)
+		Commands->Send_Custom_Event(obj,object,custom,param,delay);
+}
+void JMG_Utility_Custom_Send_Translated_String_To_All_Players::Created(GameObject *obj)
+{
+	custom = Get_Int_Parameter("Custom");
+	stringId = Get_Int_Parameter("StringID");
+	color = Get_Vector3_Parameter("ColorRGB");
+	repeatable = Get_Int_Parameter("Repeatable") ? true : false;
+}
+void JMG_Utility_Custom_Send_Translated_String_To_All_Players::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == custom)
+	{
+		JmgUtility::MessageAllPlayers((int)color.X,(int)color.Y,(int)color.Z,Get_Translated_String(stringId));
+		if (!repeatable)
+			Destroy_Script();
+	}
+}
+void JMG_Utility_Destroyed_Drop_Powerup::Destroyed(GameObject *obj)
+{
+	if (!Has_Weapon(obj,Get_Parameter("WeaponPreset")))
+		return;
+	Vector3 pos = Commands->Get_Position(obj);
+	pos.Z += Get_Float_Parameter("HeightAdjust");
+	GameObject *powerup = Commands->Create_Object(Get_Parameter("PowerupName"),pos);
+	Commands->Set_Facing(powerup,Commands->Get_Facing(obj));
+}
+void JMG_Utility_Pickup_Attach_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
+	{
+		const char *parameters = Get_Parameter("Params");
+		char *params = newstr(parameters);
+		char delim = Get_Parameter("Delim")[0];
+		unsigned int length = strlen(parameters);
+		for (unsigned int x = 0;x < length;x++)
+			if (params[x] == delim)
+				params[x] = ',';
+		Commands->Attach_Script(sender,Get_Parameter("Script"),params);
+	}
+}
+void JMG_Utility_Objective_System_Objective_Status_Update_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == Get_Int_Parameter("Custom"))
+	{
+		if (!JMG_Utility_Objective_System_Controller::controllerPlaced)
+		{
+			Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Custom ERROR: Make sure you have a JMG_Utility_Objective_System_Controller placed on the map!");
+			return;
+		}
+		int objectiveId = Get_Int_Parameter("ObjectiveID");
+		int objectiveMarkerId = Get_Int_Parameter("NewObjectiveMarkerObjectID");
+		GameObject *ObjectiveMarker = objectiveMarkerId == -1 ? sender : Commands->Find_Object(objectiveMarkerId);
+		if (!ObjectiveMarker && objectiveMarkerId)
+		{
+			Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Enter ERROR: Could not find objective marker object!");
+			return;
+		}
+		int stringId = Get_Int_Parameter("NewObjectiveStringID");
+		BasicObjectiveSystem.Add_Objective(objectiveId,NewObjectiveSystem::Primary,NewObjectiveSystem::Hidden,0,"",0);
+		BasicObjectiveSystem.Set_Objective_Mission(objectiveId,stringId,stringId);
+		if (ObjectiveMarker)
+			BasicObjectiveSystem.Set_Radar_Blip(objectiveId,ObjectiveMarker,NULL);
+		JmgUtility::SetHUDHelpText(stringId,BasicObjectiveSystem.Get_Hud_Help_Text_Color((NewObjectiveSystem::Priority)BasicObjectiveSystem.Get_Objective_Priority(objectiveId)));
+	}
+}
+void JMG_Utility_Objective_System_Objective_Failed_Custom::Created(GameObject *obj)
+{
+	custom = Get_Int_Parameter("Custom");
+}
+void JMG_Utility_Objective_System_Objective_Failed_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == custom)
+	{
+		BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("ObjectiveID"),NewObjectiveSystem::Primary,NewObjectiveSystem::Hidden,0,"",0);
+		BasicObjectiveSystem.Set_Objective_Status(Get_Int_Parameter("ObjectiveID"),NewObjectiveSystem::Failed);
+	}
+}
+void JMG_Utility_Force_Player_Team_At_Gameover::Created(GameObject *obj)
+{
+	team = Get_Int_Parameter("Team");
+	Commands->Start_Timer(obj,this,1.0,1);
+}
+void JMG_Utility_Force_Player_Team_At_Gameover::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (The_Game()->Is_Game_Over())
+			for (int x = 1;x < 128;x++)
+			{
+				cPlayer *cplayer = Find_Player(x);
+				if (!cplayer)
+					continue;
+				cplayer->Set_Player_Type(team);
+			}
+	}
+	Commands->Start_Timer(obj,this,1.0,1);
+}
+void JMG_Utility_AI_Guardian_Generic::Created(GameObject *obj)
+{
+	flightHeight = Get_Float_Parameter("FlightHeight");
+	primaryFire = Get_Int_Parameter("UseSecondaryAttack") ? false : true;
+	arriveDistance = Get_Float_Parameter("ArriveDistance");
+	arriveDistanceSq = (arriveDistance+1.0f)*(arriveDistance+1.0f);
+	dpPosition = Commands->Get_Position(obj);
+	EnemyID = 0;
+	EnemyTimeOutTime = 0;
+	LastPos = Commands->Get_Position(obj);
+	Commands->Enable_Enemy_Seen(obj,true);
+	Commands->Enable_Engine(obj,true);
+	Commands->Start_Timer(obj,this,1.0f,1);
+}
+void JMG_Utility_AI_Guardian_Generic::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (EnemyTimeOutTime)
+		{
+			EnemyTimeOutTime--;
+			if (!EnemyTimeOutTime)
+			{
+				EnemyID = 0;
+				Goto_Location(obj);
+			}
+		}
+		if (EnemyID)
+		{
+			GameObject *Target = Commands->Find_Object(EnemyID);
+			if (!Target || !Commands->Get_Health(Target) || Commands->Get_Player_Type(Target) == Commands->Get_Player_Type(obj))
+			{
+				EnemyID = 0;
+				Goto_Location(obj);
+			}
+		}
+		Vector3 Pos = Commands->Get_Position(obj);
+		Pos.Z -= flightHeight;
+		if (JmgUtility::SimpleDistance(Pos,LastPos) < arriveDistanceSq)
+		{
+			if (Get_A_Defense_Point(&dpPosition))
+				Goto_Location(obj);
+		}
+		LastPos = Pos;
+		Commands->Start_Timer(obj,this,1.0f,1);
+	}
+}
+void JMG_Utility_AI_Guardian_Generic::Enemy_Seen(GameObject *obj,GameObject *seen)
+{
+	if (Is_Script_Attached(seen,"JMG_Utility_AI_Guardian_Ignored"))
+		return;
+	if (!EnemyID || !EnemyTimeOutTime)
+	{
+		EnemyID = Commands->Get_ID(seen);
+		EnemyTimeOutTime = Commands->Get_Random_Int(2,5);
+		Goto_Location(obj);
+	}
+	else if (EnemyID == Commands->Get_ID(seen))
+		EnemyTimeOutTime = Commands->Get_Random_Int(2,5);
+}
+void JMG_Utility_AI_Guardian_Generic::Damaged(GameObject *obj,GameObject *damager,float damage)
+{
+	if (damage <= 0 || (EnemyID && EnemyTimeOutTime) || Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj))
+		return;
+	EnemyID = Commands->Get_ID(damager);
+	EnemyTimeOutTime = Commands->Get_Random_Int(2,5);
+	Goto_Location(obj);
+}
+void JMG_Utility_AI_Guardian_Generic::Goto_Location(GameObject *obj)
+{
+	ActionParamsStruct params;
+	Commands->Action_Reset(obj,100);
+	Vector3 GoToPos = dpPosition;
+	if (flightHeight)
+		GoToPos.Z += flightHeight;
+	params.MovePathfind = flightHeight ? false : true;
+	params.Set_Movement(GoToPos,Get_Float_Parameter("WanderSpeed"),arriveDistance,false);
+	params.ShutdownEngineOnArrival = Get_Int_Parameter("TurnOffEngineOnArrival") ? true : false;
+	params.Set_Basic(this,100,10);
+	GameObject *Target = Commands->Find_Object(EnemyID);
+	if (Target)
+	{
+		if (Get_Int_Parameter("FaceTarget"))
+			params.Set_Face_Location(Commands->Get_Position(Target),5.0f);
+		else
+			params.AttackFaceTarget = false;
+		params.Set_Attack(Target,Get_Float_Parameter("FireRange"),0,primaryFire);
+		params.AttackCheckBlocked = Get_Int_Parameter("CheckBlocked") ? true : false;
+		Commands->Action_Attack(obj,params);
+	}
+	else
+	{
+		if (Get_Int_Parameter("FaceTarget"))
+			params.Set_Face_Location(GoToPos,5.0f);
+		else
+			params.AttackFaceTarget = false;
+		Commands->Action_Goto(obj,params);
+	}
+}
+void JMG_Utility_Custom_Create_Object_In_Front_Of_Self::Created(GameObject *obj)
+{
+	sprintf(presetName,"%s",Get_Parameter("PresetName"));
+	custom = Get_Int_Parameter("Custom");
+	distance = Get_Float_Parameter("Distance");
+	height = Get_Float_Parameter("Height");
+	rotation = Get_Float_Parameter("Rotation");
+}
+void JMG_Utility_Custom_Create_Object_In_Front_Of_Self::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == custom)
+	{
+		Vector3 pos = Commands->Get_Position(obj);
+		float facing = Commands->Get_Facing(obj);
+		pos.X += cos(facing*PI180)*distance;
+		pos.Y += sin(facing*PI180)*distance;
+		facing += rotation;
+		pos.Z += height;
+		GameObject *object = Commands->Create_Object(presetName,pos);
+		Commands->Set_Facing(object,facing);
+	}
+}
+void JMG_Utility_Send_Custom_When_No_More_Units_On_Team_Exist_Ignore::Created(GameObject *obj)
+{
+}
+void JMG_Utility_Custom_Damage_All_Vehicles_On_Team::Created(GameObject *obj)
+{
+	custom = Get_Int_Parameter("Custom");
+	team = Get_Int_Parameter("Team");
+	damage = Get_Float_Parameter("Damage");
+	sprintf(warhead,"%s",Get_Parameter("Warhead"));
+}
+void JMG_Utility_Custom_Damage_All_Vehicles_On_Team::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == custom)
+	{
+		for (SLNode<SmartGameObj> *current = GameObjManager::SmartGameObjList.Head();current;current = current->Next())
+		{
+			SmartGameObj* o = current->Data();
+			if (o->As_VehicleGameObj() && !CheckPlayerType(o,team))
+				Commands->Apply_Damage(o,damage,warhead,o);
+		}
+	}
+}
+void JMG_Utility_Kill_Unit_If_Not_Moving_Enough::Created(GameObject *obj)
+{
+	resetTime = time = (int)(Get_Float_Parameter("Time")*10);
+	distance = Get_Float_Parameter("Distance");
+	distance *= distance;
+	lastPos = Commands->Get_Position(obj);
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Kill_Unit_If_Not_Moving_Enough::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (JmgUtility::SimpleDistance(Commands->Get_Position(obj),lastPos) < distance)
+		{
+			time--;
+			if (!time)
+				Commands->Apply_Damage(obj,999999.9f,"BlamoKiller",obj);
+		}
+		else
+		{
+			lastPos = Commands->Get_Position(obj);
+			time = resetTime;
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+void JMG_Utility_Custom_Display_Briefing_Message_StringID::Created(GameObject *obj)
+{
+	triggered = false;
+	BriefingText = NULL;
+	CurrentNode = NULL;
+	AddNewTextNode();
+	char TextString[16384];
+	sprintf(TextString,"%s",Get_Translated_String(Get_Int_Parameter("StringID")));
+	int Count = 0;
+	for (int x = 0;x < 16384;x++)
+	{
+		if ((Count > 150 && TextString[x] == ' ') || Count == 210)
+		{// String getting too long, start a new one.
+			CurrentNode->Text[Count] = '\0';
+			AddNewTextNode();
+			Count = 0;
+		}
+		else if (TextString[x] == '\n' || TextString[x] == '\0')
+		{
+			CurrentNode->Text[Count] = '\0';
+			break;// end of line your done
+		}
+		else if (TextString[x] == '\f')
+		{
+			CurrentNode->Text[Count] = '\0';
+			AddNewTextNode();
+			Count = 0;
+		}
+		else
+		{
+			CurrentNode->Text[Count] = TextString[x];
+			Count++;
+		}
+	}
+	CurrentNode = BriefingText;
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Custom_Display_Briefing_Message_StringID::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (!CurrentNode)
+		{
+			RemoveTextNodes();
+			Destroy_Script();
+			return;
+		}
+		if (CurrentNode->Text[0] != '\0')
+			for (int x = 1;x < 128;x++)
+			{
+				GameObject *Player = Get_GameObj(x);
+				if (Player)
+					JmgUtility::DisplayChatMessage(Player,(int)Get_Vector3_Parameter("MessageColor").X,(int)Get_Vector3_Parameter("MessageColor").Y,(int)Get_Vector3_Parameter("MessageColor").Z,CurrentNode->Text);
+			}
+		CurrentNode = CurrentNode->next;
+		Commands->Start_Timer(obj,this,Get_Float_Parameter("LineDelayTime"),1);
+	}
+}
+void JMG_Utility_Custom_Display_Briefing_Message_StringID::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == Get_Int_Parameter("Custom"))
+	{
+		if (triggered)
+			return;
+		triggered = true;
+		Commands->Start_Timer(obj,this,0.0f,56345344);
+		Commands->Create_2D_Sound(Get_Parameter("UISound"));
+	}
+}
+void JMG_Utility_Custom_Display_Briefing_Message_StringID::Destroyed(GameObject *obj)
+{
+	RemoveTextNodes();
+}
+void JMG_Utility_Custom_Display_Briefing_Message_StringID::AddNewTextNode()
+{
+	if (!BriefingText)
+	{
+		BriefingText = new BriefingTextNode;
+		sprintf(BriefingText->Text,"\0");
+		BriefingText->next = NULL;
+		CurrentNode = BriefingText;
+		return;
+	}
+	BriefingTextNode *Current = BriefingText;
+	while (Current)
+	{
+		if (!Current->next)
+		{
+			Current->next = new BriefingTextNode;
+			Current = Current->next;
+			sprintf(Current->Text,"\0");
+			Current->next = NULL;
+			CurrentNode = Current;
+			return;
+		}
+		Current = Current->next;
+	}
+}
+void JMG_Utility_Custom_Display_Briefing_Message_StringID::RemoveTextNodes()
+{
+	BriefingTextNode *Current = BriefingText,*Temp;
+	while (Current)
+	{
+		Temp = Current;
+		Current = Current->next;
+		delete Temp;
+	}
+	BriefingText = NULL;
+	CurrentNode = NULL;
+}
 ScriptRegistrant<JMG_Utility_Check_If_Script_Is_In_Library> JMG_Utility_Check_If_Script_Is_In_Library_Registrant("JMG_Utility_Check_If_Script_Is_In_Library","ScriptName:string,CppName:string");
 ScriptRegistrant<JMG_Send_Custom_When_Custom_Sequence_Matched> JMG_Send_Custom_When_Custom_Sequence_Matched_Registrant("JMG_Send_Custom_When_Custom_Sequence_Matched","Success_Custom=0:int,Correct_Step_Custom=0:int,Partial_Failure_Custom=0:int,Failure_Custom=0:int,Send_To_ID=0:int,Custom_0=0:int,Custom_1=0:int,Custom_2=0:int,Custom_3=0:int,Custom_4=0:int,Custom_5=0:int,Custom_6=0:int,Custom_7=0:int,Custom_8=0:int,Custom_9=0:int,Disable_On_Success=1:int,Disable_On_Failure=0:int,Starts_Enabled=1:int,Enable_Custom=0:int,Correct_Step_Saftey=0:int,Failure_Saftey=1:int,Max_Failures=1:int");
 ScriptRegistrant<JMG_Utility_Change_Model_On_Timer> JMG_Utility_Change_Model_On_Timer_Registrant("JMG_Utility_Change_Model_On_Timer","Model=null:string,Time=0:float");
@@ -7047,11 +7857,11 @@
 ScriptRegistrant<JMG_Utility_Sync_System_Object> JMG_Utility_Sync_System_Object_Registrant("JMG_Utility_Sync_System_Object","");
 ScriptRegistrant<JMG_Utility_Sync_System_Controller> JMG_Utility_Sync_System_Controller_Registrant("JMG_Utility_Sync_System_Controller","Sync_Rate=1.0:float");
 ScriptRegistrant<JMG_Utility_Sync_Object_Periodically> JMG_Utility_Sync_Object_Periodically_Registrant("JMG_Utility_Sync_Object_Periodically","Sync_Rate=1.0:float");
-ScriptRegistrant<JMG_Utility_Basic_Spawner> JMG_Utility_Basic_Spawner_Registrant("JMG_Utility_Basic_Spawner","SpawnPreset:string,RespawnTime=0.0:float,RespawnTimeRandom=0:float,StartsEnabled=1:int,EnableCustom=0:int,SpawnLimit=-1:int,DelayOnStartup=0:int");
+ScriptRegistrant<JMG_Utility_Basic_Spawner> JMG_Utility_Basic_Spawner_Registrant("JMG_Utility_Basic_Spawner","SpawnPreset:string,RespawnTime=0.0:float,RespawnTimeRandom=0:float,StartsEnabled=1:int,EnableOrDisableCustom=0:int,SpawnLimit=-1:int,DelayOnStartup=0:int");
 ScriptRegistrant<JMG_Utility_Basic_Spawner_Spawned_Object> JMG_Utility_Basic_Spawner_Spawned_Object_Registrant("JMG_Utility_Basic_Spawner_Spawned_Object","ControllerId:int");
 ScriptRegistrant<JMG_Utility_AI_Engineer> JMG_Utility_AI_Engineer_Registrant("JMG_Utility_AI_Engineer","RepaiarGun_Preset=Weapon_RepairGun_Player:string,Weapon_Preset=Weapon_Pistol_Player:string,PatrolRange=50.0:float,BaseCenterPoint=0.0 0.0 0.0:vector3,MinHP[Soldiers|Vehicles|Turrets]=0.5 0.75 0.9:vector3,MinHP[EngineerTarget|C4|Beacon]=0.25 0.0 0.0:vector3,Priority[RepairTargets|C4|Beacons]=1.0 1.0 1.0:vector3,WanderGroupID=-1:int");
 ScriptRegistrant<JMG_Utility_Set_Object_Visibility_For_Player_On_Custom> JMG_Utility_Set_Object_Visibility_For_Player_On_Custom_Registrant("JMG_Utility_Set_Object_Visibility_For_Player_On_Custom","Custom:int,PlayerID:int,Visible:int");
-ScriptRegistrant<JMG_Utility_AI_Vehicle> JMG_Utility_AI_Vehicle_Registrant("JMG_Utility_AI_Vehicle","MaxRange=25.0:float,MinAttackRange=0.0:float,FollowTarget=1:int,ReturnHome=1:int,ForceFire=0:int,VTOLHover=0.0:float,vsSoldier=1:int,vsVehicle=1:int,vsAircraft=1:int,WanderingAIGroupID=-1:int,MinRandWander=60.0:float,MaxRandWander=90.0:float,SquishInfantry=1:int,EnableTransitions=0:int,UsePathfind=1:int,DisableEngineOnArrival=1:int,WeaponError=-1.0:float,MaxHuntRange=0.0:float");
+ScriptRegistrant<JMG_Utility_AI_Vehicle> JMG_Utility_AI_Vehicle_Registrant("JMG_Utility_AI_Vehicle","MaxRange=25.0:float,MinAttackRange=0.0:float,FollowTarget=1:int,ReturnHome=1:int,ForceFire=0:int,VTOLHover=0.0:float,vsSoldier=1:int,vsVehicle=1:int,vsAircraft=1:int,WanderingAIGroupID=-1:int,MinRandWander=60.0:float,MaxRandWander=90.0:float,SquishInfantry=1:int,EnableTransitions=0:int,UsePathfind=1:int,DisableEngineOnArrival=1:int,WeaponError=-1.0:float,MaxHuntRange=0.0:float,NextWanderPointWhenLastReached=0.0:float");
 ScriptRegistrant<JMG_Utility_Dynamic_Clock_Control> JMG_Utility_Dynamic_Clock_Control_Registrant("JMG_Utility_Dynamic_Clock_Control","");
 ScriptRegistrant<JMG_Utility_Dynamic_Clock_Object> JMG_Utility_Dynamic_Clock_Object_Registrant("JMG_Utility_Dynamic_Clock_Object","");
 ScriptRegistrant<JMG_Utility_Change_Screen_Color_While_In_Zone> JMG_Utility_Change_Screen_Color_While_In_Zone_Registrant("JMG_Utility_Change_Screen_Color_While_In_Zone","Color[Red|Green|Blue]:vector3,Opacity:float,EnterFadeInTime:float,ExitFadeOutTime:float");
@@ -7087,7 +7897,7 @@
 ScriptRegistrant<JMG_Utility_AI_Aggressive_Attack_Spot_Control> JMG_Utility_AI_Aggressive_Attack_Spot_Control_Registrant("JMG_Utility_AI_Aggressive_Attack_Spot_Control","");
 ScriptRegistrant<JMG_Utility_AI_Aggressive_Attack_Spot_Point> JMG_Utility_AI_Aggressive_Attack_Spot_Point_Registrant("JMG_Utility_AI_Aggressive_Attack_Spot_Point","GroupId=0:int,AttackOffset=0.0 0.0 0.0:Vector3");
 ScriptRegistrant<JMG_Utility_AI_Aggressive_Attack_Spot_Point2> JMG_Utility_AI_Aggressive_Attack_Spot_Point2_Registrant("JMG_Utility_AI_Aggressive_Attack_Spot_Point2","GroupId=0:int,AbsolutePosition=0.0 0.0 0.0:Vector3,ObjectID=0:int");
-ScriptRegistrant<JMG_Utility_AI_Aggressive_Attack_Spot> JMG_Utility_AI_Aggressive_Attack_Spot_Registrant("JMG_Utility_AI_Aggressive_Attack_Spot","GroupId=-1:int,SecondaryGroupId=-1:int,AttackPointSpeed=1.0:float,AttackPointDistance=-1.0:float,RandomAttackPointDistance=0.0:float,AttackSpeed=1.0:float,AttackDistance=-1.0:float,RandomAttackDistance=0.0:float,ReturnHome=0:int,ReturnHomeSpeed=1.0:float,ReactToAttackChance=0.5:float,ReactToAttackRate=10.0:float,ShutdownEngineOnArrival=0:int,EnableDebug=0:int");
+ScriptRegistrant<JMG_Utility_AI_Aggressive_Attack_Spot> JMG_Utility_AI_Aggressive_Attack_Spot_Registrant("JMG_Utility_AI_Aggressive_Attack_Spot","GroupId=-1:int,SecondaryGroupId=-1:int,AttackPointSpeed=1.0:float,AttackPointDistance=-1.0:float,RandomAttackPointDistance=0.0:float,AttackSpeed=1.0:float,AttackDistance=-1.0:float,RandomAttackDistance=0.0:float,ReturnHome=0:int,ReturnHomeSpeed=1.0:float,ReactToAttackChance=0.5:float,ReactToAttackRate=10.0:float,ShutdownEngineOnArrival=0:int,EnableDebug=0:int,UseSecondaryFire=0:int");
 ScriptRegistrant<JMG_Utility_Destroy_Objects_In_ID_Range_On_Death> JMG_Utility_Destroy_Objects_In_ID_Range_On_Death_Registrant("JMG_Utility_Destroy_Objects_In_ID_Range_On_Death","StartID:int,EndID:int");
 ScriptRegistrant<JMG_Utility_Custom_Enable_Spawners_In_Range> JMG_Utility_Custom_Enable_Spawners_In_Range_Registrant("JMG_Utility_Custom_Enable_Spawners_In_Range","StartID:int,EndID:int,Custom:int,Enable=1:int");
 ScriptRegistrant<JMG_Utility_Send_Custom_On_Player_Count> JMG_Utility_Send_Custom_On_Player_Count_Registrant("JMG_Utility_Send_Custom_On_Player_Count","PlayerCount=0:int,ID=0:int,Custom:int,Param:int,Delay:float,TriggerOn[eq|<|>]=1.0 0.0 0.0:vector3,SupressMatchSpam=1:int,DestroyAfterTrigger=0:int");
